VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   Caption         =   "Personal Message Store Export Utility"
   ClientHeight    =   4665
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7725
   LinkTopic       =   "Form1"
   ScaleHeight     =   4665
   ScaleWidth      =   7725
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cbCancel 
      Caption         =   "Cancel"
      Enabled         =   0   'False
      Height          =   495
      Left            =   2520
      TabIndex        =   12
      Top             =   4080
      Width           =   1215
   End
   Begin MSComctlLib.ProgressBar ProgressBar1 
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   3600
      Visible         =   0   'False
      Width           =   7455
      _ExtentX        =   13150
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.ListBox List3 
      Height          =   1815
      Left            =   5160
      TabIndex        =   8
      Top             =   240
      Width           =   2415
   End
   Begin VB.ListBox List2 
      Height          =   1815
      Left            =   2640
      TabIndex        =   7
      Top             =   240
      Width           =   2415
   End
   Begin VB.TextBox edtMessageFile 
      Height          =   375
      Left            =   1080
      TabIndex        =   6
      Text            =   "c:\messages.txt"
      Top             =   2290
      Width           =   5175
   End
   Begin VB.ListBox List1 
      Height          =   1815
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   2415
   End
   Begin VB.CommandButton cbExport 
      Caption         =   "&Export"
      Height          =   495
      Left            =   3960
      TabIndex        =   0
      Top             =   4080
      Width           =   1215
   End
   Begin VB.Label lblMessageCount 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Messages"
      Height          =   195
      Left            =   6840
      TabIndex        =   10
      Top             =   2160
      Width           =   720
   End
   Begin VB.Label lblMessageID 
      AutoSize        =   -1  'True
      Caption         =   "None"
      Height          =   195
      Left            =   1080
      TabIndex        =   9
      Top             =   2880
      Width           =   390
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Export File:"
      Height          =   195
      Left            =   120
      TabIndex        =   5
      Top             =   2400
      Width           =   780
   End
   Begin VB.Label lblSubject 
      AutoSize        =   -1  'True
      Caption         =   "None"
      Height          =   195
      Left            =   1080
      TabIndex        =   4
      Top             =   3240
      Width           =   390
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Subject:"
      Height          =   195
      Left            =   435
      TabIndex        =   3
      Top             =   3240
      Width           =   585
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Message ID:"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   2880
      Width           =   900
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
 
  Dim objSession As MAPI.Session
  Dim objFolder1 As Folder
  Dim objFolders1 As Folders
  Dim objFolder2 As Folder
  Dim objFolders2 As Folders
  Dim objInfoStoresColl As InfoStores
  Dim objInfoStore As InfoStore
  Dim bolContinue As Boolean
  
  
Private Sub cbCancel_Click()
  bolContinue = False
End Sub

Private Sub cbExport_Click()
  On Error Resume Next
  ProgressBar1.Visible = True
  cbExport.Enabled = False
  cbCancel.Enabled = True
  bolContinue = True
  
  If (List3.ListIndex = -1) And (List2.ListIndex = -1) Then
    MsgBox "No Message Folder Selected"
    Exit Sub
  End If
  
  If List3.ListIndex > -1 Then
    For Each objFolder2 In objFolders2
      If objFolder2.Name = List3.Text Then
        SaveMessagesToFile objFolder2
      End If
    Next
  Else
    For Each objFolder1 In objFolders1
      If objFolder1.Name = List2.Text Then
        SaveMessagesToFile objFolder1
      End If
    Next
  End If
  ProgressBar1.Visible = False
  MsgBox "Export Complete", [vbInformation], "PST Export"
  cbExport.Enabled = True
  cbCancel.Enabled = False
End Sub

Private Sub Form_Load()
  On Error Resume Next
  Dim intCollIndex As Integer
  
  ' Logon to the MAPI session
  Set objSession = New MAPI.Session
  objSession.Logon
  Set objInfoStoresColl = objSession.InfoStores
  If objInfoStoresColl Is Nothing Then
      MsgBox "Could not set InfoStores collection"
      Exit Sub
  End If
  If 0 = objInfoStoresColl.Count Then
      MsgBox "No InfoStores in the collection"
      Exit Sub
  End If
  For Each objInfoStore In objInfoStoresColl
    List1.AddItem (objInfoStore.Name)
  Next
End Sub

Public Sub SaveMessagesToFile(objFolder As Folder)
  On Error Resume Next
  Dim objMsgColl As Messages
  Dim objMessage As Message
  Dim strHeaders As String
  Dim strText As String
  Dim intCounter As Long
  
  Set objMsgColl = objFolder.Messages

  ' Search through the messages in the Inbox for the Internet
  ' message.  Then use the CdoPR_TRANSPORT_MESSAGE_HEADERS
  ' (&H7D001E) property tag to retrieve the Internet header.
  ' If the property doesn't exist(Not a Internet message) you will
  ' receive a MAPI_E_NOT_FOUND error.
  Open edtMessageFile.Text For Output As #1
  
  ProgressBar1.Max = objMsgColl.Count
  lblMessageCount.Caption = objMsgColl.Count
  intCounter = 0
  
  For Each objMessage In objMsgColl
     strHeaders = objMessage.Fields(&H7D001E)
     strText = objMessage.Text
     lblSubject.Caption = objMessage.Subject
     lblMessageID.Caption = objMessage.Fields(&H1035001E)
     intCounter = intCounter + 1
     ProgressBar1.Value = intCounter
     DoEvents
     If strHeaders <> "" Then
       Print #1, strHeaders
     Else
       Print #1, "Message-ID: " & lblMessageID.Caption
       Print #1, "From: " & objMessage.Sender
       Print #1, "To: " & objMessage.Recipients
       Print #1, "Subject: " & objMessage.Subject
       Print #1, "Date: " & objMessage.TimeSent
       Print #1, ""
     End If
     Print #1, strText
     Print #1, Chr(12)
     If bolContinue = False Then Exit For
  Next
  
  Close #1
  lblSubject.Caption = "None"
  lblMessageID.Caption = "None"
  lblMessageCount.Caption = "Messages"
  Set objMessage = Nothing
  Set objMsgColl = Nothing
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error Resume Next
  ' SaveMessages
  ' Logoff and cleanup
  objSession.Logoff
  Set objSession = Nothing
  Set objFolder1 = Nothing
  Set objFolders1 = Nothing
  Set objFolder2 = Nothing
  Set objFolders2 = Nothing
End Sub

Private Sub List1_Click()
  On Error Resume Next
  For Each objInfoStore In objInfoStoresColl
    If objInfoStore.Name = List1.Text Then
      Set objFolder1 = objInfoStore.RootFolder
      Set objFolders1 = objFolder1.Folders
      List2.Clear
      For Each objFolder1 In objFolders1
        List2.AddItem (objFolder1.Name)
      Next
      Exit Sub
    End If
  Next
End Sub

Private Sub List2_Click()
  On Error Resume Next
  For Each objFolder1 In objFolders1
    If objFolder1.Name = List2.Text Then
      Set objFolders2 = objFolder1.Folders
      List3.Clear
      For Each objFolder2 In objFolders2
        List3.AddItem (objFolder2.Name)
      Next
      Exit Sub
    End If
  Next
End Sub

